#####################################################################
# Copyright (C) 2000 Artur Trzewik
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
######################################################################
# Header
# CVS - $Id: ass_assistent.tcl,v 1.6 2000/10/15 17:19:20 artur Exp $
#
# Information:
# Modul (benutzt von Schema Editor)
# GUI Dialoge (Assistenten) fr ergnze des DB Schema um Informationen
# Wie Assoziation, Aggregation und Vererbung
Object AssAssistent
AssAssistent metadata add prop
# rel relationship table (n:m Relationship)
# rek rekursiv
# nrek not rekursiv
# nrel not relationship table (1:n Relationship)
AssAssistent metadata prop {
    {relationship_count {count}}
    {rekursiv_reltable {rekursiv relationshiptable}}
    {relation_table {table_rel collectionname description}}
    {reference_table {table_rel collectionname ref_minoccurs ref_rolename description}}
    {relation {object_num table_object rolename maxOccurs minOccurs ondelete onupdate reference}}
}
AssAssistent metadata add propspec
# rel relationship table (n:m Relationship)
# rek rekursiv
# nrek not rekursiv
# nrel not relationship table (1:n Relationship)
AssAssistent metadata propspec {
    {count {{type OLabelControl} {default 2}}}
    {rekursiv {{type OCheckButton}}}
    {relationshiptable {{type OCheckButton}}}
    {table_object {{type OComboBox} }}
    {table_rel {{type OComboBox}  }}
    {reference {{type OComboBox} }}
    {collectionname {{type OLabelEntry} {textwidth 20}}}
    {rolename {{type OLabelEntry} {textwidth 20}}}
    {ref_rolename {{type OLabelEntry} {textwidth 20}}}
    {description {{type OLabelEntry} {textwidth 20}}}
    {table {{type OComboBox} {valuelist {} }}}
    {maxOccurs {{type OLabelEntry} {textwidth 20}}}
    {minOccurs {{type OLabelEntry} {textwidth 20}}}
    {object_num {{type OLabelEntry} {textwidth 5} {state disabled}}}
    {ref_minoccurs {{type ORadioButtons} {valuelist {0 1}} }}
    {ondelete {{type OComboBox} {valuelist {nothing delete setnull}} }}
    {onupdate {{type OComboBox} {valuelist {nothing update setnull}} }}
}
AssAssistent proc buildWindow {} {
    [self] instvar win
    global lan
    catch {destroy $win}
    toplevel $win -class Dialog
    wm title $win $lan(ass_label.title)
    wm iconname $win Dialog
    wm protocol $win WM_DELETE_WINDOW {AssAssistent button_cancel}
    message $win.message
    frame $win.inputframe -relief sunken
    tixButtonBox $win.buttons -orientation horizontal
    $win.buttons add ok -text $lan(standard.ok) -command "AssAssistent button_ok"
    $win.buttons add back -text $lan(standard.back) -command "AssAssistent button_back"
    $win.buttons add cancel -text $lan(standard.cancel) -command "AssAssistent button_cancel"

    pack $win.message -side top -fill x -expand 1
    pack $win.inputframe -side top -fill both -expand 1
    pack $win.buttons -side bottom -fill x -expand 1

    focus $win
}
# Baut einem FrameImput Container mit Input-Widget nach prop und
# propspec Spezifikation und setzt ihn in das Fenster
# die Felder werden wie Objectvarioablen initiert
#
# Beim tabel_rel wird spezielle prozedur Aufgerufen 
# um valuelist zu spezifizieren
#
AssAssistent proc buildCard {name} {
    [self] instvar win defaultref count
    global lan
    # Wenn eine Inputframe existiert dann lschen
    if {[[self] info children inputframe]!=""} {
	[self]::inputframe unmap
    }
    set propspec [[self] metadata propspec]
    set prop [[self] metadata prop]
    foreach attr [keylget prop $name] {
	set klist [keylget propspec $attr]
	# Label sprachspezifisch setzten
	keylset klist label [set lan(ass_label.$attr)]
	    # Name setzen genau so wie die Attribut Name
	keylset klist name $attr
	#puts "info vars  [[self] info invar]"
	if {[lcontain [[self] info vars] $attr]} {
	    [self] instvar $attr
	    #puts "default 1 $attr"
	    set val [set $attr]
	    if {$val!=""} {
		#puts "default $attr $val"
		keylset klist default $val
	    }
	}
	if {[info exist defaultref($attr)]} {
	    foreach key [keylkeys defaultref($attr)] {
		keylset klist $key [keylget defaultref($attr) $key]
	    }
	}
	lappend inputlist $klist
    }
    WidgetFactory make_inputs_keylist [self]::inputframe $inputlist
    [self]::inputframe map $win.inputframe.if
    pack $win.inputframe.if
    if {[info exist defaultref]} {
	unset defaultref
    }
}
# Stellt eine Liste mit Allen Tabellen
AssAssistent proc gettables type {
    # tDom
    [self] instvar domNode
    if {$type=="object"} {
	[self] instvar table_rel
	set tables [$domNode selectNodes descendant::table\[@name!=\"$table_rel\"\]/attribute::name]
    } else {
	set tables [$domNode selectNodes descendant::table\[@type!=\"relationship\"\]/attribute::name]
#       tDom0.4 Bug Workaround
#        set tables_temp [$domNode selectNodes descendant::table
# 	foreach tnode $tables_temp {
# 	    if {[$tnode hasAttribute type] &&
# 	    [$tnode getAttribute type]=="relationship"} {
# 		#puts nothing
# 	    } else {
# 		lappend tables [$tnode getAttribute name]
# 	    }
# 	}
    }
    return [concat **** $tables]
}
AssAssistent proc getreferences type {
    # tDom
    [self] instvar domNode table_rel
    return [concat **** [$domNode selectNodes descendant::table\[@name="$table_rel"\]/descendant::attr/attribute::name]]
}
# Edit Node ist ein Init Node, das fr initzierung genuztz wird
AssAssistent proc execute {dom {editNode {}}} {
    [self] instvar domNode win evaluator ehistory relarray  defaultref
    set win .assistent
    set domNode $dom
    lappend ehistory {ev_relationship_count relationship_count}
    set propspec [[self] metadata propspec]
    foreach var [keylkeys propspec] {
	[self] instvar $var
	set $var {}
    }
    if {[info exist relarrey]} {
	unset relarray
    }
    if {[info exist ehistory]} {
	set ehistory {}
    }
    if {[info exist defaultref]} {
	unset defaultref
    }
    if {$editNode!=""} {
	[self] initFromNode $editNode
    }
    [self] buildWindow
    [self] buildCard relationship_count
    set evaluator ev_relationship_count
}
AssAssistent proc initFromNode {node} {
    [self] instvar count rekursiv relationshiptable table_object \
	table_rel reference collectionname rolename ref_rolename \
	description table maxOccurs minOccurs ref_minoccurs ondelete onupdate \
	editNode
    set editNode $node
    if {[$node nodeName]=="assoziationcollection"} {
	[self] initFromAC $node
    } elseif {[$node nodeName]=="assoziationtarget"} {
	set cnodes [$node selectNodes /descendant::assoziationcollection\[@name=\"[$node getAttribute name]\"\]]
	[self] initFromAC [lindex $cnodes 0]
    }
}
# extrahiere assoziationcollection Node
AssAssistent proc initFromAC {node} {
    [self] instvar count rekursiv relationshiptable table_object \
	table_rel reference collectionname rolename ref_rolename \
	description table maxOccurs minOccurs ref_minoccurs ondelete onupdate \
	editNode
    set collectionname [$node getAttribute name]
    set table_rel [lindex [$node selectNodes ancestor::table/attribute::name] 0]
    set description [tdom_getpername $node description]
    set p_nodes [$node selectNodes child::participant] 
    set count [llength $p_nodes]
    set relcount 0
    foreach p_node $p_nodes {
	[self] initFromP $p_node $relcount
	incr relcount 
    }
    if {[$node getAttribute type]=="reftable"} {
	set  relationshiptable 1
    } else {
	incr count
	set  relationshiptable 0
	if {[$node hasAttribute rolename]} {
	    set ref_rolename [$node getAttribute rolename]
	}
	if {[$node hasAttribute minOccurs]} {
	    set ref_minoccurs [$node getAttribute minOccurs]
	}
    }
}
# kann nur von initFromAC aufgerufen werden
# gewisse Objektvariablen mssen bereit existieren
AssAssistent proc initFromP {node id} {
    [self] instvar relarray collectionname table_rel
    keylset attr table_object [$node getAttribute table]
    keylset attr reference [$node getAttribute reference]
    # Suche den entsprechenden assoziationtarget
    if  [$node hasAttribute rolename] {
	set at_node [$node selectNodes "//descendant::assoziationtarget\[@name=\"$collectionname\" and @rolename=\"[$node getAttribute rolename]\"\]"]
    } else {
	set at_node [$node selectNodes "//descendant::table\[@name=\"[$node getAttribute table]\"\]/child::assoziationtarget\[@name=\"$collectionname\"\]"]
    }
    if {$at_node==""} {
	error "can't find assoziationtarget Node. Schema Corrupt"
    }
    append attr " " [tdom_attr2keyl $at_node]
    set relarray($id) $attr
}
# Transeriert die Werte aus InputFrame zu objekt Variablen
AssAssistent proc inputToVars {} {
    [self]::inputframe update_values
    set values [[self]::inputframe get_values]
    #puts "Values $values"
    foreach val [keylkeys values] {
	[self] instvar $val
	set $val [keylget values $val]
    }
}
AssAssistent proc button_cancel {} {
    [self] instvar win inputframe
    destroy $win
    [self]::inputframe destroy
}
AssAssistent proc button_ok {} {
    [self] instvar evaluator
    [self] inputToVars
    set nextcard [[self] $evaluator]
    if {$nextcard=="END"} {
	[self] applyToXml
	[self] button_cancel
    } elseif {$nextcard!="HALT"} {
	# Gibt es einen Prepare Schritt
	if {[[self] info procs p$evaluator]!=""} {
	    p$evaluator
	}
	[self] buildCard $nextcard
    }
}
AssAssistent proc button_back {} {
    [self] instvar evaluator ehistory
    set last [lindex $ehistory end]
    set evaluator [lindex $last 0]
    if {[[self] info procs p$evaluator]!=""} {
	p$evaluator
    }
    [self] buildCard [lindex $last 1]
    set hlen [llength $ehistory]
    if {$hlen>1} {
	set ehistory [lrange $ehistory 0 [expr $hlen-2]]
    }
}
# Diese Prozedur schreibt die Assoziazion zu XML Struktur und gibt 
# die nderungen an ProgGui weiter
AssAssistent proc applyToXml {} {
    [self] instvar domNode collectionname relationshiptable table_rel \
	relarray count description ref_rolename ref_minoccurs
    set domDoc [$domNode ownerDocument]
    # wenn nicht vorhanden dann collectionname generieren
    if {$collectionname==""} {
	if {$relationshiptable} {
	    set collectionname $table_rel
	} else {
	    set collectionname "[keylget relarray(0) table_object]$table_rel"
	}
    }
    # Allte Assoziation falls vorhanden lschen
    set anodes [$domNode selectNodes /descendant::assoziationtarget\[@name=\"$collectionname\"\]]
    if {$anodes!=""} {
	# Suche assoztioncontainer
	set cnodes [$domNode selectNodes /descendant::assoziationcollection\[@name=\"$collectionname\"\]]
	set anodes [concat $anodes $cnodes]
	set rltable [[lindex $cnodes 0] parentNode]
	if {[$rltable hasAttribute type] && [$rltable getAttribute type]=="relationship"} {
	    $rltable removeAttribute type
	    ProgGui applyChanges $rltable
	    #puts HIER
	}
	foreach dnode $anodes {
	    serviceSEdit deleteElem $dnode
	}
    }
    # generiere Relationship-eintrag (node assoziationcollection)
    if {$relationshiptable} {
	# Suche Table Node
	set rt_node [$domNode selectNodes \
		descendant::table\[@name="$table_rel"\]]
	$rt_node setAttribute type relationship
	# GUI verndern
	ProgGui applyChanges $rt_node
	set ac_node [$domDoc createElement assoziationcollection]
	$ac_node setAttribute name $collectionname
	$ac_node setAttribute type reftable
	tdom_setpername $ac_node description $description
	$rt_node appendChild $ac_node
	# Vernderungen an GUI weitergeben
	ProgGui addElem $ac_node $rt_node 1
	# Erster Durchauf nachsehen ob es rekursive Beziehungen gibt
	# und mglicherweise RolenNamen ergnzen
	set relobj {}; set rek_obj {}
	for {set x 0} {$x<$count} {incr x} {
	    set table [keylget relarray($x) table_object]
	    if {[lcontain $relobj $table]} {
		lappend rek_obj $table
	    } else {
		lappend relobj $table
	    }
	}
	#puts "rek_obj $rek_obj relobj $relobj"
	# Zwieter Durchlauf participiant und associationtarget Tag erzeugen
	for {set x 0} {$x<$count} {incr x} {
	    set attr $relarray($x)
	    set p_node [$domDoc createElement participant]
	    $p_node setAttribute reference [keylget attr reference]
	    set table [keylget attr table_object]
	    $p_node setAttribute table $table
	    if {[lcontain $rek_obj $table] &&
		[keylget attr rolename]==""} {
		keylset attr rolename [keylget attr reference]
		#puts "seting rolename"
	    }
	    if {[keylget attr rolename]!=""} {
		$p_node setAttribute rolename [keylget attr rolename]
	    }
	    $ac_node appendChild $p_node
	    # generiere Beziehungs-Objekte-Beschreibung 
	    # (node assoziationtarget)
	    targetToXml $attr $collectionname
	}
    } else {
	# Suche Table Node
	set rt_node [$domNode selectNodes \
		descendant::table\[@name="$table_rel"\]]
	set ac_node [$domDoc createElement assoziationcollection]
	keylset nattr name $collectionname
	keylset nattr type reference
	keylset nattr minOccurs $ref_minoccurs
	keylset nattr rolename $ref_rolename
	tdom_keyl2attr $ac_node $nattr {
	    {rolename {}}
	    {minOccurs {}}
	}
	tdom_setpername $ac_node description $description
	$rt_node appendChild $ac_node
	# Vernderungen an GUI weitergebe
	ProgGui addElem $ac_node $rt_node 1
	set attr $relarray(0)
	set p_node [$domDoc createElement participant]
	$p_node setAttribute reference [keylget attr reference]
	$p_node setAttribute table [keylget attr table_object]
	# RollenName setzen falls existiert
	if {[lcontain [keylkeys attr] rolename]} {
	    $p_node setAttribute rolename [keylget attr rolename]
	}
	# Wenn rekursive Beziehung und keine Rollen Namen dann FremdSchlssel
	# wird zum Rollen Namen
	if {$table_rel==[keylget attr table_object] && [keylget attr rolename]==""} {
	    $p_node setAttribute rolename [keylget attr reference]
	    keylset attr rolename [keylget attr reference]
	}
	$ac_node appendChild $p_node
	# generiere Beziehungs-Objekte-Beschreibung 
	# Beschreibung des Ziels des Verweis (Reference)
	# (node assoziationtarget)
	targetToXml $attr $collectionname
    }     
}
AssAssistent proc targetToXml {attr collectionname} {
    [self] instvar domNode table_rel
    set t_node  [$domNode selectNodes \
		     descendant::table\[@name="[keylget attr table_object]"\]]
    set at_node [[$domNode ownerDocument] createElement assoziationtarget]
    keylset attr name $collectionname
    keylset attr table $table_rel
    tdom_keyl2attr $at_node $attr {
	{minOccurs {}}
	{maxOccurs {}}
	{rolename {}}
	{ondelete nothing}
	{onupdate nothing}
    } {minOccurs maxOccurs rolename table ondelete onupdate name}
    $t_node appendChild $at_node
    # nderungen an GUI weitergeben
    ProgGui addElem $at_node $t_node 1
}
# Hier ist die ganze Logik des Assistenten eingebaut
# Wenn ein OK Button gedrckt wird, wird die Prozedur in Varibale
# evaluator ausgefhrt er gibt auch den nchsten Card das Angezeigt werden soll
# durch Array defaultref werden die Attributen den einzelnen Inputfelder
# (s. propspec) berschrieben
# Die Evaluator Prozedur kann auch zwei spezielle Kommand weitergeben
# "END" fr die Letzte Karte 
# und "HALT" fr nichts machen (z.B. wenn Inputs unvollsttndig)
# !! Problem - Keine bermittlung von Letzten Karte, was ein Button "Fertig"
#               mglich machen konnte. Der Benutzter wei nicht wann er
#               am Ende des Assistents ist.
# ehistory ist ein Liste, die fr die Funktion zurck zustndigt ist.
# jeder Evaluator fgt dazu sein name und name des Cards (GUI)
AssAssistent proc ev_relationship_count {} {
    [self] instvar evaluator count defaultref relationshiptable ehistory rekursiv
    lappend ehistory {ev_relationship_count relationship_count}
    if {$count>2} {
	keylset defaultref(table_rel) valuelist  [[self] gettables rel]
	set evaluator ev_relation_table
	set relationshiptable 1
	set rekursiv 0
	return relation_table
    } else {
	set evaluator ev_rekursiv_reltable
	return rekursiv_reltable
    }
}
AssAssistent proc ev_rekursiv_reltable {} {
    [self] instvar evaluator ehistory defaultref relationshiptable
    lappend ehistory {ev_rekursiv_reltable rekursiv_reltable}
    # Vorbereiten nchstes Schritt
    if {$relationshiptable} {
	set evaluator ev_relation_table
	return relation_table
    } else {
	set evaluator ev_reference_table
	return reference_table
    }
}
AssAssistent proc pev_relation_table {} {
    [self] instvar defaultref
    keylset defaultref(table_rel) valuelist  [[self] gettables rel]
}
AssAssistent proc ev_relation_table {} {
    [self] instvar evaluator relcount ehistory table_rel
    if {$table_rel=="" || $table_rel=="****"} {
	global lan
	tk_messageBox -message $lan(ass_label.notablerel) -type ok -icon error
	return HALT
    }
    lappend ehistory {ev_relation_table relation_table}
    # Vorbereiten nchstes Schritt
    set relcount 0
    set evaluator ev_relation
    return relation
}
AssAssistent proc pev_reference_table {} {
    [self] instvar defaultref
    keylset defaultref(table_rel) valuelist  [[self] gettables rel]
}
AssAssistent proc ev_reference_table {} {
    [self] instvar evaluator relcount ehistory defaultref table_rel
    if {$table_rel=="" || $table_rel=="****"} {
	global lan
	tk_messageBox -message $lan(ass_label.notable) -type ok -icon error
	return HALT
    }
    lappend ehistory {ev_reference_table reference_table}
    set relcount 0
    set evaluator ev_relation
    return relation
}
# Wird kurz bovor des Einzeigen von reltion card Ausgefrt um die
# Anzeige Daten vorzubereiten
AssAssistent proc pev_relation {} {
    [self] instvar defaultref tab_list ref_list relationshiptable \
	rekursiv table_rel defaultref relcount table_object relarray \
	reference rolename
    set rolename {}
    if {$relcount==0} {
	set tab_list [[self] gettables object]
	set ref_list [[self] getreferences object]
	keylset defaultref(table_object) valuelist $tab_list
	keylset defaultref(reference) valuelist $ref_list
    } else {
	keylset defaultref(table_object) valuelist $tab_list
	for {set x 0} {$x<$relcount} {incr x} {
	    set attr $relarray($x)
	    lappend ref_old [keylget attr reference]
	}
	keylset defaultref(reference) valuelist [minusMenge $ref_list $ref_old]
	set reference [lindex [keylget defaultref(reference) valuelist] 0]
    }
    [self] expandRelation
    keylset defaultref(object_num) default [expr $relcount +1 ]
    if {$rekursiv} {
	if {$relcount!=0 || !$relationshiptable} {
	    # Beim n:m Rekursiv das Objekt wird nur das erste mal gewhlt
	    if {!$relationshiptable} {
		# Beim 1:n Rekursiv Objekt ist gleich Container (Verweis
		# auf ein Objekt gleiches Typs
		set table_object $table_rel
	    }
	    keylset defaultref(table_object) state disabled
	}
    }
}
AssAssistent proc ev_relation {} {
    [self] instvar evaluator relcount count relationshiptable table_object reference
    if {$table_object=="" || $table_object=="****" || 
	$reference=="" || $reference=="****"} {
	global lan
	tk_messageBox -message $lan(ass_label.notablerel) -type ok -icon error
	return HALT
    }
    [self] saveRelation
    incr relcount
    if {$relcount!=$count && $relationshiptable} {
	[self] expandRelation
	set evaluator ev_relation
	return relation
    }
    return END
}
# Speichert das Ergebniss von ev_relation als eine Struktur 
# (keyed list in relarray)
AssAssistent proc saveRelation {} {
    [self] instvar relcount relarray
    #set prop [[self] metadata prop]
    [self]::inputframe update_values
    set relarray($relcount) [[self]::inputframe get_values]
}

# Transferiert die Daten einer Beziehung (gespeicert in Array relarray) 
# zu Objektvariablen
AssAssistent proc expandRelation {} {
    [self] instvar relcount relarray
    if {[info exist relarray($relcount)]} {
	set values $relarray($relcount)
	#puts "expanding $relcount $values"
	foreach attr [keylkeys values] {
	    #puts "expanding $attr"
	    [self] instvar $attr
	    set $attr [keylget values $attr]
	}
    }
}
#
# Objekt fr Dialog (Definieren von Aggregationen)
#
Object AggrAssistent
# Stellt eine Liste mit Allen Tabellen
AggrAssistent proc gettables type {
    # tDom
    [self] instvar domNode
    set tables [$domNode selectNodes descendant::table\[@type!=\"relationship\"\]/attribute::name]
    return [concat **** $tables]
}
AggrAssistent proc getreferences type {
    # tDom
    [self] instvar domNode table_rel
    return [concat **** [$domNode selectNodes descendant::table\[@name="$table_rel"\]/descendant::attr/attribute::name]]
}
AggrAssistent set input_spec {
    {container {{type OComboBox}}}
    {aggr_table {{type OComboBoxN} {notifyproc {AggrAssistent chooseTable}} }}
    {reference  {{type OComboBox}  {valuelist ****}}}
    {maxOccurs {{type OLabelEntry} {textwidth 20}}}
    {minOccurs {{type OLabelEntry} {textwidth 20}}}
}
AggrAssistent proc execute {dom} {
    [self] instvar domNode win evaluator ehistory relarray
    set domNode $dom
    global lan
    # Build InputFrame
    if {[[self] info children inputframe]==""} { 
	set tablelist [[self] gettables object] 
	foreach attr [keylkeys [self]::input_spec] {
	    set klist [keylget [self]::input_spec $attr]
	    # Label sprachspezifisch setzten
	    keylset klist label [set lan(aggr_label.$attr)]
	    # Name setzen genau so wie die Attribut Name
	    keylset klist name $attr
	    if {$attr=="container" || $attr=="aggr_table"} {
		keylset klist valuelist $tablelist
	    }
	    lappend inputlist $klist
	}
	WidgetFactory make_inputs_keylist [self]::inputframe $inputlist
    }
    ODialog [self]::connectdialog -title $lan(aggr_label.title) \
        -message $lan(connect.mysql)\
        -inputframe [self]::inputframe -type okcancel        
    if {[connectdialog execute]=="cancel"} { return } 
    [self] inputToVars
    [self] instvar aggr_table container reference
    if {$aggr_table=="****" || $container=="****" || $reference=="****"} {
	tk_messageBox -message $lan(aggr_label.badinput) -type ok -icon error
    } else {
	[self] applyToXml
    }
    [self]::connectdialog destroy
}
# Ein Callback wenn die Aggregierte-Tabelle ausgewlt wurde
AggrAssistent proc chooseTable value {
    [self] instvar domNode
    #puts "Notify $value"
    if {$value!="****"} {
	set attrlist [concat **** [$domNode selectNodes descendant::table\[@name=\"$value\"\]/descendant::attr/attribute::name]]
	[self]::inputframe::reference setvaluelist $attrlist
    }
}
# Transeriert die Werte aus InputFrame zu objekt Variablen
AggrAssistent proc inputToVars {} {
    set values [[self]::inputframe get_values]
    foreach val [keylkeys values] {
	[self] set $val [keylget values $val]
    }
}
# Diese Prozedur schreibt die Aggregation zu XML Struktur und gibt 
# die nderungen an ProgGui weiter
AggrAssistent proc applyToXml {} {
    [self] instvar domNode aggr_table minOccurs maxOccurs container reference
    if {$aggr_table==$container} { 
	error "Die Tabelle kann sich nicht selber beinhalten"
	return 
    }
    set tba_node  [$domNode selectNodes \
		     descendant::table\[@name=\"$aggr_table\"\]]
    set c_node  [$domNode selectNodes \
		     descendant::table\[@name=\"$container\"\]]
    # Entferne die eventuel bestehende Assoziation
    # collection
    set acoll  [$tba_node selectNodes child::assoziationcollection\[child::participant\[@table=\"$container\"\]\]]
    if {$acoll!=""} {
	foreach node $acoll {
	    serviceSEdit deleteElem $node
	}
        # target 
	set atarg [$c_node selectNodes child::assoziationtarget\[@table=\"$aggr_table\"\]]
    	foreach node $atarg {
	    serviceSEdit deleteElem $node
	}
    }
    keylset v minOccurs $minOccurs
    keylset v maxOccurs $maxOccurs
    tdom_keyl2attr $tba_node $v {
	{maxOccurs {}}
	{minOccurs {}}
    }
    $tba_node setAttribute reference $reference
    [$tba_node parentNode] removeChild $tba_node
    $c_node appendChild $tba_node
    # nderungen an GUI weitergeben
    ProgGui moveElem $tba_node $c_node 1
}
#
# Objekt fr Dialog (Definieren von Vererbung)
#
Object InheritAssistent
# Stellt eine Liste mit Allen Tabellen
InheritAssistent proc gettables type {
    # tDom
    [self] instvar domNode
    set tables [$domNode selectNodes descendant::table\[@type!=\"relationship\"\]/attribute::name]
    return [concat **** $tables]
}
InheritAssistent proc getreferences type {
    # tDom
    [self] instvar domNode table_rel
    return [concat **** [$domNode selectNodes descendant::table\[@name="$child_table"\]/descendant::attr/attribute::name]]
}
InheritAssistent set input_spec {
    {parent_table {{type OComboBox}}}
    {child_table {{type OComboBoxN} {notifyproc {InheritAssistent chooseTable}} }}
    {reference  {{type OComboBox}  {valuelist ****}}}
    {inherittype {{type OComboBox} {valuelist {unknown notsubset subset {parent abstract}}} }}
}
InheritAssistent proc execute {dom} {
    [self] instvar domNode win evaluator ehistory relarray
    set domNode $dom
    global lan
    # Build InputFrame
    if {[[self] info children inputframe]==""} { 
	set tablelist [[self] gettables object] 
	foreach attr [keylkeys [self]::input_spec] {
	    set klist [keylget [self]::input_spec $attr]
	    # Label sprachspezifisch setzten
	    keylset klist label [set lan(inherit_label.$attr)]
	    # Name setzen genau so wie die Attribut Name
	    keylset klist name $attr
	    if {$attr=="parent_table" || $attr=="child_table"} {
		keylset klist valuelist $tablelist
	    }
	    lappend inputlist $klist
	}
	WidgetFactory make_inputs_keylist [self]::inputframe $inputlist
    }
    ODialog [self]::connectdialog -title $lan(inherit_label.title) \
        -message $lan(connect.mysql)\
        -inputframe [self]::inputframe -type okcancel        
    if {[connectdialog execute]=="cancel"} { return } 
    [self] inputToVars
    [self] instvar parent_table child_table reference
    if {$parent_table=="****" || $child_table=="****" || $reference=="****"} {
	tk_messageBox -message $lan(inherit_label.badinput) -type ok -icon error    
    } else {
	[self] applyToXml
    }
    [self]::connectdialog destroy
}
# Ein Callback wenn die Inheritegierte-Tabelle ausgewlt wurde
InheritAssistent proc chooseTable value {
    [self] instvar domNode
    #puts "Notify $value"
    if {$value!="****"} {
	set attrlist [concat **** [$domNode selectNodes descendant::table\[@name=\"$value\"\]/descendant::attr/attribute::name]]
	[self]::inputframe::reference setvaluelist $attrlist
    }
}
# Transeriert die Werte aus InputFrame zu objekt Variablen
InheritAssistent proc inputToVars {} {
    set values [[self]::inputframe get_values]
    foreach val [keylkeys values] {
	[self] set $val [keylget values $val]
    }
}
# Diese Prozedur schreibt die Vererbung zu XML Struktur und gibt 
# die nderungen an ProgGui weiter
InheritAssistent proc applyToXml {} {
    [self] instvar domNode parent_table child_table minOccurs maxOccurs reference inherittype
    if {$child_table==$parent_table} { 
	error "Die Tabelle kann sich nicht selber erben"
	return 
    }
    set p_node  [$domNode selectNodes \
		     descendant::table\[@name=\"$parent_table\"\]]
    set tba_node  [$domNode selectNodes \
		     descendant::table\[@name=\"$child_table\"\]]
    $tba_node setAttribute inherittype $inherittype
    $tba_node setAttribute type child
    $tba_node setAttribute inheritkey $reference
    [$tba_node parentNode] removeChild $tba_node
    $p_node appendChild $tba_node
    # nderungen an GUI weitergeben
    ProgGui moveElem $tba_node $p_node 1
    ProgGui applyChanges $tba_node
}
